;;-----------------------------------------------------------------------
	.EXPORTALL

	;; MMPS internal heap. In this heap are allocated
	;; all blocks, for the process, the stack, the FS
	;; and the entries (FILE, QUEUE, CONSOLE...)
baseHEAP	.EQU	&__/baseHEAP/
topHEAP		.EQU	&__/topHEAP/
tableHEAP	.EQU	&__/tableHEAP/
maxIndexHEAP	.EQU	&__/maxIndexHEAP/

	;; MMPS process table. All administrative date of
	;; the process are here
tablePROC:	.EQU	&__/basePROC/00
maxIndexPROC	.EQU	&__/basePROC/80

	;; MMPS file-system (FS). The pointers to the blocks
	;; of entries. All entries are stored in a block, 4
	;; entries by block
tableFS		.EQU	&__/basePROC/80
maxIndexFS	.EQU	&__/basePROC/A0
maskFS		.EQU	&30

	;; MMPS descriptor (DS). All entries opened, exec
	;; running process get a reference in this table
tableDS		.EQU	&__/tableDS/
maxIndexDS	.EQU	&__/maxIndexDS/
maxDS		.EQU	&__/maxDS/

	;; Buffer space for the kernel
kernelBUF	.EQU	&__/basePROC/A0

	;; Stack for the kernel. Really used by the CONSOLE
	;; task
conTASKSP	.EQU	&__/basePROC/D5
conTASKSTACK	.EQU	&__/basePROC/DF
kernelSTACK	.EQU	&__/basePROC/EF
kernelinitSTACK	.EQU	&__/basePROC/F1

	;; SEED number used for the temporary file name.
tmpSEED		.EQU	&__/basePROC/F4

conPROC		.EQU	&__/basePROC/F6
conPROC.SP	.EQU	&__/basePROC/FA
currentCON	.EQU	&__/basePROC/FC
endingPROC	.EQU	&__/basePROC/FD

	;; Pointer to the real process-structure, used when
	;; the console TASK run with the PID of a process
effectivePROC	.EQU	&__/basePROC/FE

	;; Internal PID of the current running process
currentPROC	.EQU	&__/basePROC/FF

	;; Internal kernel PID (FS, ...)
conPID		.EQU	&F6
	;; LCD indicators used by the console TASK
conLCD.PIN	.EQU	&40	; I   -> Pending INPUT
conLCD.POUT	.EQU	&20	; II  -> Pending OUTPUT
conLCD.PCUR	.EQU	&10	; III -> Pending on CURent console
	;; special keys managed by the console TASK
conKEY.OFF	.EQU	&0F	; key OFF
conKEY.UP	.EQU	&0B	; key UP arrow
conKEY.DWN	.EQU	&0A	; key DWN arrow
conKEY.LFT	.EQU	&08	; key LFT arrow
conKEY.RGT	.EQU	&0C	; key RGT arrow
conKEY.CLR	.EQU	&18	; key CLR
conKEY.CA	.EQU	&1A	; key CA
conKEY.RCL	.EQU	&19	; key RCL
conKEY.SLC	.EQU	&09	; key SLC
conKEY.DEL	.EQU	&1D	; key DEL
conKEY.INS	.EQU	&1C	; key INS
conKEY.ENTER	.EQU	&0D	; key ENTER

	;; LH5801 CPU specifics
cpuF.EI		.EQU	&02	; EI flag in F

	.IF	LESS?	tableHEAP tablePROC
	.FATAL	"tablePROC should be first"
	.ENDIF
	.IF	LESS?	tableDS tablePROC
	.FATAL	"tablePROC should be first"
	.ENDIF

SYSVAR.start:	.EQU	tablePROC
	.IF	LESS?	tableHEAP tableDS
SYSVAR.length:	.ARRAYOF BYTE maxIndexDS tablePROC
	.ELSE
SYSVAR.length:	.ARRAYOF BYTE maxIndexHEAP tablePROC
	.ENDIF

SYSMEM.start:	.EQU	baseHEAP
SYSMEM.length:	.ARRAYOF BYTE topHEAP baseHEAP

	;; First and second NODE pages
NODE.first:	.EQU	&1980
NODE.second:	.EQU	&19C0

