	.IF	INCLUDED?
	;; Align on next 64-bytes frontier
	.ALIGN:	40
	.ELSE
	;; Origin does not matter, because code
	;; and data are fully relocatable.
	.ORIGIN: 40C5
	.ENDIF

	.CODE
	.COMMENT:	PROCESS - Copyright 1994-2014 Christophe Gottheimer <cgh75015@gmail.com>

	;; PROCESS - Display all process created
	;; PROCESS try to get the process status
	;; (STA) for all process (0..7). If it
	;; succeed, the process status bits and
	;; and the executable name are displayed.
	;; Else, go to next process-id.

	;; When the console output is refreshed by
	;; pressing the key RCL, the next process
	;;s is displayed

	;; MMPS kernel-jump and macros
	;;
	.INCLUDE:	MMPS.inc

PROCESS:
	.LOCAL

	.BYTE
	BLDHEADER	PROCESS.asm$$._length 01 0040

	.CODE
	;; program enters here
	;;   BC contains the global address
	;;   DE the in and out descriptors
	;;   HL points to the arguments

	;; HL points to argument page. We use
	;; this dummy page allocated to pass
	;; the arguments. Because we do not
	;; expect some, it is our buffer !
	;; This is not nice, but it reduces
	;; the space needed.
	LD	BC,HL

	;; The first process had pid 0
	LD	H,00

forever:
	;; Prepare for STA, pid in H and BC
	;; points to the process structure
	LDA	H
	PUSH	A
	STI	(BC)
	MMPS	krn.STA
	POP	A
	STA	H
	DEC	BC
	;; If carry clear, the process does
	;; not exists, so go next
	JR	NC,nextproc

	;; Save all registers
	PUSH	HL
	PUSH	BC
	PUSH	DE

	LD	DE,BC
	LDA	10
	ADD	DE
	LD	HL,BC
	PUSH	DE

	LD	BC,PC
	LDA	*_*processSTR
	ADD	BC
	;; Here call the FMTSRING from the run
	;; time with in
	;;    BC the format string
	;;    DE the formatted string
	;;    HL the structure to format
	CALL	FMTSTRING

	;; Restore all registers
	POP	BC
	POP	DE

	;; Write the formatted buffer to the out
	;; descriptor
	LD	L,18
	MMPS	krn.WRI

	POP	BC
	POP	HL
nextproc:
	INC	H
	;; Up to 8 process under MMPS
	CP	H,08
	JR	NC,forever

	;; Flush the out descriptor. This is nice
	;; if we output to a console, because we
	;; will suspend until RCL is pressed. It
	;; gives time for user to read the output.
	MMPS	krn.FLU

	;; Return to father with &0000
	CLA
	STA	D
	STA	E
	RET
	SBC	C

	.TEXT
processSTR:
	".L .P .L .B .L  .S          \00"

	.END

