	.IF	INCLUDED?
	;; Align on next 64-bytes frontier
	.ALIGN:	40
	.ELSE
	;; Origin does not matter, because code
	;; and data are fully relocatable.
	.ORIGIN: 40C5
	.ENDIF

	.CODE
	.COMMENT:	SHOWKEY - Copyright 1994-2014 Christophe Gottheimer <cgh75015@gmail.com>

	;; SHOWKEY - Get a key from a console and print
	;; the ASCII code to the same console
	;;

	;; MMPS kernel-jump and macros
	;;
	.INCLUDE:	MMPS.inc

SHOWKEY:
	.LOCAL

	;; MMPS executable header. Perhaps a macro, no?
	;
	.BYTE
	BLDHEADER	SHOWKEY.asm$$._length 01 0000

	;;
	.CODE
	;; The process enters here
	;;   BC = global address
	;;   D in and E out descriptor
	;;   HL = argument address
	LD	BC,HL

	;; Get the descriptor type and access into H
	MMPS	krn.DES
	JR	NC,outerr
	LDA	H

	;; We expect a console exclusively
	BIT	10
	JR	Z,outerrcon

forever:
	;; Get on key from the console. When key is
	;; pressed, we return immediately
	LD	L,01
	MMPS	krn.REA

	;; Error on read ? We just exit
	JR	NC,outerr

	LDA	(BC)
	PUSH	A
	CALL	highTOHEX
	STI	(BC)
	POP	A
	CALL	lowTOHEX
	STD	(BC)

	;; Refresh the console. This will avoid
	;; to be susped if a message is pending.
	MMPS	krn.RFR

	;; Write the ASCII code to console
	LD	L,02
	MMPS	krn.WRI
	JR	forever

outerrcon:
	;; Return No such descriptor
	LDA	err.NOD
outerr:
	;; Error. Return error code from A into
	;; E and set D to 0.
	LD	D,00
	STA	E
	RET

	.END

