;;=======================================================================
;;	DISCLAIMER
;;
;;	You use this program, executables and libraries at your own risks.
;;	I am mot responsible for any damage hardware or software resulting
;;	from the use of this program and from the programs, executables or
;;	libraries developed with this software.
;;=======================================================================


	;;
	;; MMPS - Mini Multi Process System
	;; A small operation system for the SHARP PC-1500/A and TANDY PC-2
	;;
	;; Copyright 1994-2014 Christophe Gottheimer <cgh75015@gmail.com>
	;;

	;; 
	.ORIGIN: 1800

	.CODE
	.COMMENT: 	MMPS minimal fs and runtime - Copyright 1994-2014 Christophe Gottheimer <cgh75015@gmail.com>

	.INCLUDE:	MMPS.inc
	.INCLUDE:	MMPS.volatile.inc

	;; Run-Time library (FMTSTRING, NEXTARG...)
	;;
	.INCLUDE:	RTLIB.asm

	.ALIGN: 0080

	;; Macro to build a NODE entry into the File-System
	;;
	.MACRO:	BLDNODENTRY
		>[|24]__#0
		01
		<__#1 >__#1
		[>6][=6]__#2
		<__#2 >__#2
		__#3
	.ENDMACRO

	.BYTE

	;; First node page
	;;
	.IF	EQUAL?	NODE.first .
	.ELSE
	.FATAL	"NODE.first differs"
	.ENDIF

	BLDNODENTRY 00 SYSVAR.start SYSVAR.length "SYSVAR"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY 00 SYSMEM.start SYSMEM.length "SYSMEM"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY fs.XEQ STARTER.asm$$._start STARTER.asm$$._length "STARTER"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY fs.XEQ FILES.asm$$._start FILES.asm$$._length "FILES"
	.FILLALIGN:	10 WITH 00

	.BYTE

	;; Second node page
	;;
	.IF	EQUAL?	NODE.second .
	.ELSE
	.FATAL	"NODE.second differs"
	.ENDIF

	BLDNODENTRY fs.XEQ PROCESS.asm$$._start PROCESS.asm$$._length "PROCESS"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY fs.XEQ DISPLAY.asm$$._start DISPLAY.asm$$._length "DISPLAY"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY fs.XEQ DEBUG.asm$$._start DEBUG.asm$$._length "DEBUG"
	.FILLALIGN:	10 WITH 00

	BLDNODENTRY fs.XEQ MAKER.asm$$._start MAKER.asm$$._length "MAKER"
	.FILLALIGN:	10 WITH 00


	.ALIGN:	0100

	;; STARTER executable - Run another process and catch return
	;;
	.INCLUDE:	STARTER.asm

	.ALIGN:	0040

	;; FILES executable - List all entries in the File-System
	;;
	.INCLUDE:	FILES.asm

	.ALIGN:	0040

	;; PROCESS executable - List all the current process
	;;
	.INCLUDE:	PROCESS.asm

	.ALIGN:	0040

	;; DISPLAY executable - Dump in hexadecimal the content of the entry
	;;			named in argument
	;;
	.INCLUDE:	DISPLAY.asm

	.ALIGN:	0040

	;; DEBUG executable - Run and debug the executable named in argument
	;;
	.INCLUDE:	DEBUG.asm

	.ALIGN:	0040

	;; MAKER executable - Copy the executable code from the BASIC area
	;;
	.INCLUDE:	MAKER.asm

	.ALIGN:	0040

	.END
